package org.diagbot.nlp.rule.pretreat;

import org.diagbot.nlp.participle.ParticipleUtil;
import org.diagbot.nlp.participle.word.Lexeme;
import org.diagbot.nlp.participle.word.LexemePath;
import org.diagbot.nlp.rule.module.PreResult;
import org.diagbot.nlp.util.NegativeEnum;
import org.diagbot.nlp.util.NlpUtil;

import java.util.ArrayList;
import java.util.List;

/**
 * Created by louhr on 2019/12/9.
 */
public class PretreatmentPersonal extends Pretreatment {
    protected NegativeEnum[] nees_allergy = new NegativeEnum[]{NegativeEnum.PERSON_FEATURE_DESC, NegativeEnum.BLOOD, NegativeEnum.BAD_HABBIT};

    public List<PreResult> analyze(String content) throws java.io.IOException{
        List<PreResult> preResults = new ArrayList<>();
        LexemePath<Lexeme> lexemes = ParticipleUtil.participle(content);
        for (int i = 0; i < lexemes.size(); i++) {
            Lexeme l = lexemes.get(i);
            if (NlpUtil.isFeature(l.getProperty(), nees_allergy)) {
                PreResult result = new PreResult();
                result.setUniqueName("个人--");
                result.setDetailName("个人--");
                result.setValue(l.getText());
                preResults.add(result);
            }
        }
        return preResults;
    }

    public PreResult createPreResult(LexemePath<Lexeme> lexemes, Lexeme lexeme, int index) {
        return null;
    }

    public String findBodyValue(LexemePath<Lexeme> lexemes, Lexeme lexeme, int index) {
        return null;
    }
}
